//+--------------------------------------------------------------------+
//|                                           ke_BuySell_Odnovremenno.mq4  |
//|                                           Skype:  mqlcoder         |
//|                                           E-mail: mqlcoder@mail.ru |
//+--------------------------------------------------------------------+
#property copyright "Copyright 2016, Sergey Kasirenko"
#property link      "https://www.mql5.com/ru/users/sergeyhelp/feedbacks"
#property version   "1.00"
#property strict
//+--------------------------------------------------------------------------------------------------------+
extern  double    Lot   = 0.1;
input   string    Time1_Sessii  = "04:00";     //  
input   string    Time2_Sessii  = "10:00";     //   ( : )
extern  int       Slippage      = 3;    
extern  double    TP            = 200;         // 
extern  double    SL            = 200;         // 
extern  double    TRAL          = 100;         // (0 -  )
extern  int       Magic         = 21112016;
 
//+------------------------------------------------------------------+
  int Barss;
  color cvet_arrow[6]={Blue,Red,Blue,Red,Blue,Red};
  bool Flag_Open_Buy,Flag_Open_Sell;
  double d0;
  double Filtr;
  bool flag_uje_otkrili;
  
  
//==============================================================================================================================================================
//--------------------------------------------------------------------------------------------------------------------------------------------------------------
//==============================================================================================================================================================

void OnInit()
{
   Barss=-1;
   TRAL*=Point;  
   TP*=Point;
   SL*=Point;
   if(Lot<MarketInfo(Symbol(),MODE_MINLOT)) 
   {
     Lot=MarketInfo(Symbol(),MODE_MINLOT);
     Alert("  : ",Lot);
   }
}  
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   TRAL/=Point;  
   TP/=Point;
   SL/=Point;
   
}  

//==============================================================================================================================================================
void OnTick()
{
//----
   OPEN_ORDERS();  
   TRAL_FUNC();
   
//----
   return;
}
//+------------------------------------------------------------------+
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void OPEN_ORDERS()//       
{
  double sl=0,tp=0,vh=0,nLot;
  string s;
  int j,type;
  datetime tStart1=0,tStart2=0;
  
  tStart1=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+Time1_Sessii); 
  if(Time2_Sessii!="") tStart2=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+Time2_Sessii); 
  
  bool flag_open_ord=false;
  if(TimeCurrent()>=tStart1 && TimeCurrent()<tStart1+40) flag_open_ord=true;
  if(TimeCurrent()>=tStart2 && TimeCurrent()<tStart2+40) flag_open_ord=true;
  
  if(flag_open_ord==false) flag_uje_otkrili=false;
  //+------------------------------------------------------------------+
  //|    
  //+------------------------------------------------------------------+
  s=""; 
  nLot=Lot;
  type=-1;
  bool flag_buy=false;
  if(flag_uje_otkrili==false && flag_open_ord)
  {
     type=OP_BUY;
     nLot=Lot;
     s="";
     j=0;
     if(IsTradeAllowed() && !IsTradeContextBusy() && IsConnected())
       while(j<7)
       {
         RefreshRates();
         vh=Ask;
         tp=TP==0?0:vh+TP;
         sl=SL==0?0:vh-SL;
         if(OrderSend(Symbol(),type,NormalizeDouble(nLot,2),vh,Slippage,sl,tp,s,Magic,0,cvet_arrow[type])==-1) 
         {
           Print("F: ",__FUNCTION__,"()  L: ",__LINE__,".  Open type: ",type," LastError: ",_LastError,"  Ask = ",Ask,"  Bid = ",Bid);
           j++;
         }  
         else
         {
           flag_buy=true;
           break;
         } 
       }  
     type=OP_SELL;
     nLot=Lot;
     s="";
     j=0;
     if(IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && flag_buy)
       while(j<7)
       {
         RefreshRates();
         vh=Bid;
         tp=TP==0?0:vh-TP;
         sl=SL==0?0:vh+SL;
         if(OrderSend(Symbol(),type,NormalizeDouble(nLot,2),vh,Slippage,sl,tp,s,Magic,0,cvet_arrow[type])==-1) 
         {
           Print("F: ",__FUNCTION__,"()  L: ",__LINE__,".  Open type: ",type," LastError: ",_LastError,"  Ask = ",Ask,"  Bid = ",Bid);
           j++;
         }  
         else
         {
           flag_uje_otkrili=true;
           break;
         } 
       }  
  }  
  
  return;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  
void TRAL_FUNC()
{
  int i;
  double sl;
  if(TRAL==0) return;
  //---   ---
  for(i=0;i<OrdersTotal();i++)
    if(OrderSelect(i,SELECT_BY_POS))
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
      {
        RefreshRates();
        double SlipZone=NormalizeDouble(MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,Digits);
        double Askk=NormalizeDouble(Ask,Digits);
        double Bidd=NormalizeDouble(Bid,Digits);
        if(TRAL<=SlipZone) TRAL=SlipZone+Point;
        if(OrderType()==OP_BUY && Bidd-OrderOpenPrice()>TRAL)
        {
           sl=0;
           if(OrderStopLoss()==0) sl=NormalizeDouble(Bidd-TRAL,Digits);
           else
             if(Bidd-OrderStopLoss()>TRAL) sl=NormalizeDouble(Bidd-TRAL,Digits);
           //Print("ere sl = ",sl,"  Tral_Shag = ",Tral_Shag,"  TrailStep = ",TrailStep,"  _TrailStep = ",_TrailStep);
           if(NormalizeDouble(OrderStopLoss(),Digits)<sl && sl!=0 && Bidd-sl>SlipZone)    
             if(IsTradeAllowed() && !IsTradeContextBusy() && IsConnected())
               if(!OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0))
                 Print("F: ",__FUNCTION__,"()  L: ",__LINE__,".    BUY   Tic: ",OrderTicket(),"   OrdStop = ",OrderStopLoss(),"  new SL = ",sl,"  Ask = ",Askk,"  +Bidd = ",Bidd,"  SlipZone = ",SlipZone);
        }                                         
        if(OrderType()==OP_SELL && OrderOpenPrice()-Askk>TRAL)
        {
           sl=0;
           if(OrderStopLoss()==0) sl=NormalizeDouble(Askk+TRAL,Digits); 
           else
             if(OrderStopLoss()-Askk>TRAL) sl=NormalizeDouble(Askk+TRAL,Digits);
           if( (NormalizeDouble(OrderStopLoss(),Digits)>sl || NormalizeDouble(OrderStopLoss(),Digits)==0) && sl!=0 && sl-Askk>SlipZone)    
               if(IsTradeAllowed() && !IsTradeContextBusy() && IsConnected())
                 if(!OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0))
                   Print("F: ",__FUNCTION__,"()  L: ",__LINE__,".    SELL   Tic: ",OrderTicket(),"   OrdStop = ",OrderStopLoss(),"  new SL = ",sl,"  +Ask = ",Askk,"  Bidd = ",Bidd,"  SlipZone = ",SlipZone);
        }                                         
      }  
}//if(Flag_Tral)
   
